##// END OF EJS Templates
Fix default KERNEL_DEFAULT_GOV value - as in README file.
Michał Ciołek -
r588:0ba4e305dbfe
parent child
Show More
@@ -1,869 +1,869
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47
47
48 # Kernel Branch
48 # Kernel Branch
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50
50
51 # URLs
51 # URLs
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62
62
63 # Kernel deb packages for 32bit kernel
63 # Kernel deb packages for 32bit kernel
64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 # Default precompiled 64bit kernel
68 # Default precompiled 64bit kernel
69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 # Generic
70 # Generic
71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
72 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
72 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
73 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
73 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
74
74
75 # Build directories
75 # Build directories
76 WORKDIR=$(pwd)
76 WORKDIR=$(pwd)
77 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
77 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
78 BUILDDIR="${BASEDIR}/build"
78 BUILDDIR="${BASEDIR}/build"
79
79
80 # Chroot directories
80 # Chroot directories
81 R="${BUILDDIR}/chroot"
81 R="${BUILDDIR}/chroot"
82 ETC_DIR="${R}/etc"
82 ETC_DIR="${R}/etc"
83 LIB_DIR="${R}/lib"
83 LIB_DIR="${R}/lib"
84 BOOT_DIR="${R}/boot/firmware"
84 BOOT_DIR="${R}/boot/firmware"
85 KERNEL_DIR="${R}/usr/src/linux"
85 KERNEL_DIR="${R}/usr/src/linux"
86 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
86 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
87 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
87 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
88
88
89 # Firmware directory: Blank if download from github
89 # Firmware directory: Blank if download from github
90 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
90 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
91
91
92 # General settings
92 # General settings
93 SET_ARCH=${SET_ARCH:=32}
93 SET_ARCH=${SET_ARCH:=32}
94 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
94 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
95 PASSWORD=${PASSWORD:=raspberry}
95 PASSWORD=${PASSWORD:=raspberry}
96 USER_PASSWORD=${USER_PASSWORD:=raspberry}
96 USER_PASSWORD=${USER_PASSWORD:=raspberry}
97 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
97 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
98 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
98 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
99 EXPANDROOT=${EXPANDROOT:=true}
99 EXPANDROOT=${EXPANDROOT:=true}
100 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
100 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
101
101
102 # Keyboard settings
102 # Keyboard settings
103 XKB_MODEL=${XKB_MODEL:=""}
103 XKB_MODEL=${XKB_MODEL:=""}
104 XKB_LAYOUT=${XKB_LAYOUT:=""}
104 XKB_LAYOUT=${XKB_LAYOUT:=""}
105 XKB_VARIANT=${XKB_VARIANT:=""}
105 XKB_VARIANT=${XKB_VARIANT:=""}
106 XKB_OPTIONS=${XKB_OPTIONS:=""}
106 XKB_OPTIONS=${XKB_OPTIONS:=""}
107
107
108 # Network settings (DHCP)
108 # Network settings (DHCP)
109 ENABLE_DHCP=${ENABLE_DHCP:=true}
109 ENABLE_DHCP=${ENABLE_DHCP:=true}
110
110
111 # Network settings (static)
111 # Network settings (static)
112 NET_ADDRESS=${NET_ADDRESS:=""}
112 NET_ADDRESS=${NET_ADDRESS:=""}
113 NET_GATEWAY=${NET_GATEWAY:=""}
113 NET_GATEWAY=${NET_GATEWAY:=""}
114 NET_DNS_1=${NET_DNS_1:=""}
114 NET_DNS_1=${NET_DNS_1:=""}
115 NET_DNS_2=${NET_DNS_2:=""}
115 NET_DNS_2=${NET_DNS_2:=""}
116 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
116 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
117 NET_NTP_1=${NET_NTP_1:=""}
117 NET_NTP_1=${NET_NTP_1:=""}
118 NET_NTP_2=${NET_NTP_2:=""}
118 NET_NTP_2=${NET_NTP_2:=""}
119
119
120 # APT settings
120 # APT settings
121 APT_PROXY=${APT_PROXY:=""}
121 APT_PROXY=${APT_PROXY:=""}
122 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
122 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
123 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
123 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
124
124
125 # Feature settings
125 # Feature settings
126 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
126 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
127 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
127 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
128 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
128 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
129 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
129 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
130 ENABLE_I2C=${ENABLE_I2C:=false}
130 ENABLE_I2C=${ENABLE_I2C:=false}
131 ENABLE_SPI=${ENABLE_SPI:=false}
131 ENABLE_SPI=${ENABLE_SPI:=false}
132 ENABLE_IPV6=${ENABLE_IPV6:=true}
132 ENABLE_IPV6=${ENABLE_IPV6:=true}
133 ENABLE_SSHD=${ENABLE_SSHD:=true}
133 ENABLE_SSHD=${ENABLE_SSHD:=true}
134 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
134 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
135 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
135 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
136 ENABLE_SOUND=${ENABLE_SOUND:=true}
136 ENABLE_SOUND=${ENABLE_SOUND:=true}
137 ENABLE_DBUS=${ENABLE_DBUS:=true}
137 ENABLE_DBUS=${ENABLE_DBUS:=true}
138 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
138 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
139 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
139 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
140 ENABLE_XORG=${ENABLE_XORG:=false}
140 ENABLE_XORG=${ENABLE_XORG:=false}
141 ENABLE_WM=${ENABLE_WM:=""}
141 ENABLE_WM=${ENABLE_WM:=""}
142 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
142 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
143 ENABLE_USER=${ENABLE_USER:=true}
143 ENABLE_USER=${ENABLE_USER:=true}
144 USER_NAME=${USER_NAME:="pi"}
144 USER_NAME=${USER_NAME:="pi"}
145 ENABLE_ROOT=${ENABLE_ROOT:=false}
145 ENABLE_ROOT=${ENABLE_ROOT:=false}
146 ENABLE_QEMU=${ENABLE_QEMU:=false}
146 ENABLE_QEMU=${ENABLE_QEMU:=false}
147 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
147 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
148
148
149 # SSH settings
149 # SSH settings
150 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
150 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
151 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
151 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
152 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
152 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
153 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
153 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
154 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
154 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
155
155
156 # Advanced settings
156 # Advanced settings
157 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
157 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
162 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
162 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
163 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
163 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
164 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
164 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
165 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
165 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
166 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
166 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
167 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
167 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
168 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
168 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
169 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
169 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
170 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
170 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
171 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
171 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
172 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
172 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
173 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
173 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
174 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
174 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
175 ENABLE_LOGO=${ENABLE_LOGO:=true}
175 ENABLE_LOGO=${ENABLE_LOGO:=true}
176 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
176 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
177 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
177 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
178
178
179 # Kernel compilation settings
179 # Kernel compilation settings
180 BUILD_KERNEL=${BUILD_KERNEL:=true}
180 BUILD_KERNEL=${BUILD_KERNEL:=true}
181 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
181 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
182 KERNEL_THREADS=${KERNEL_THREADS:=1}
182 KERNEL_THREADS=${KERNEL_THREADS:=1}
183 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
183 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
184 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
184 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
185 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
185 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
186 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
186 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
187 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
187 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
188 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
188 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
189 KERNEL_VIRT=${KERNEL_VIRT:=false}
189 KERNEL_VIRT=${KERNEL_VIRT:=false}
190 KERNEL_BPF=${KERNEL_BPF:=false}
190 KERNEL_BPF=${KERNEL_BPF:=false}
191 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=powersave}
191 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
192 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
192 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
193 KERNEL_NF=${KERNEL_NF:=false}
193 KERNEL_NF=${KERNEL_NF:=false}
194
194
195 # Kernel compilation from source directory settings
195 # Kernel compilation from source directory settings
196 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
196 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
197 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
197 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
198 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
198 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
199 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
199 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
200
200
201 # Reduce disk usage settings
201 # Reduce disk usage settings
202 REDUCE_APT=${REDUCE_APT:=true}
202 REDUCE_APT=${REDUCE_APT:=true}
203 REDUCE_DOC=${REDUCE_DOC:=true}
203 REDUCE_DOC=${REDUCE_DOC:=true}
204 REDUCE_MAN=${REDUCE_MAN:=true}
204 REDUCE_MAN=${REDUCE_MAN:=true}
205 REDUCE_VIM=${REDUCE_VIM:=false}
205 REDUCE_VIM=${REDUCE_VIM:=false}
206 REDUCE_BASH=${REDUCE_BASH:=false}
206 REDUCE_BASH=${REDUCE_BASH:=false}
207 REDUCE_HWDB=${REDUCE_HWDB:=true}
207 REDUCE_HWDB=${REDUCE_HWDB:=true}
208 REDUCE_SSHD=${REDUCE_SSHD:=true}
208 REDUCE_SSHD=${REDUCE_SSHD:=true}
209 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
209 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
210
210
211 # Encrypted filesystem settings
211 # Encrypted filesystem settings
212 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
212 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
213 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
213 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
214 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
214 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
215 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
215 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
216 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
216 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
217 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
217 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
218 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
218 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
219 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
219 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
220 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
220 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
221
221
222 # Chroot scripts directory
222 # Chroot scripts directory
223 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
223 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
224
224
225 # Packages required in the chroot build environment
225 # Packages required in the chroot build environment
226 APT_INCLUDES=${APT_INCLUDES:=""}
226 APT_INCLUDES=${APT_INCLUDES:=""}
227 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
227 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
228
228
229 # Packages to exclude from chroot build environment
229 # Packages to exclude from chroot build environment
230 APT_EXCLUDES=${APT_EXCLUDES:=""}
230 APT_EXCLUDES=${APT_EXCLUDES:=""}
231
231
232 # Packages required for bootstrapping
232 # Packages required for bootstrapping
233 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
233 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
234 MISSING_PACKAGES=""
234 MISSING_PACKAGES=""
235
235
236 # Packages installed for c/c++ build environment in chroot (keep empty)
236 # Packages installed for c/c++ build environment in chroot (keep empty)
237 COMPILER_PACKAGES=""
237 COMPILER_PACKAGES=""
238
238
239 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
239 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
240 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
240 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
241 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
241 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
242 APT_PROXY=http://127.0.0.1:3142/
242 APT_PROXY=http://127.0.0.1:3142/
243 fi
243 fi
244
244
245 # Setup architecture specific settings
245 # Setup architecture specific settings
246 if [ -n "$SET_ARCH" ] ; then
246 if [ -n "$SET_ARCH" ] ; then
247 # 64-bit configuration
247 # 64-bit configuration
248 if [ "$SET_ARCH" = 64 ] ; then
248 if [ "$SET_ARCH" = 64 ] ; then
249 # General 64-bit depended settings
249 # General 64-bit depended settings
250 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
250 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
251 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
251 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
252 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
252 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
253
253
254 # Raspberry Pi model specific settings
254 # Raspberry Pi model specific settings
255 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
255 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
256 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
256 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
257 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
257 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
258 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
258 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
259 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
259 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
260 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
260 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
261 else
261 else
262 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
262 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
263 exit 1
263 exit 1
264 fi
264 fi
265 fi
265 fi
266
266
267 # 32-bit configuration
267 # 32-bit configuration
268 if [ "$SET_ARCH" = 32 ] ; then
268 if [ "$SET_ARCH" = 32 ] ; then
269 # General 32-bit dependend settings
269 # General 32-bit dependend settings
270 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
270 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
271 KERNEL_ARCH=${KERNEL_ARCH:=arm}
271 KERNEL_ARCH=${KERNEL_ARCH:=arm}
272 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
272 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
273
273
274 # Raspberry Pi model specific settings
274 # Raspberry Pi model specific settings
275 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
275 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
276 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
276 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
277 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
277 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
278 RELEASE_ARCH=${RELEASE_ARCH:=armel}
278 RELEASE_ARCH=${RELEASE_ARCH:=armel}
279 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
279 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
280 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
280 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
281 fi
281 fi
282
282
283 # Raspberry Pi model specific settings
283 # Raspberry Pi model specific settings
284 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
284 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
285 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
285 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
286 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
286 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
287 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
287 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
288 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
288 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
289 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
289 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
290 fi
290 fi
291 fi
291 fi
292 # SET_ARCH not set
292 # SET_ARCH not set
293 else
293 else
294 echo "error: Please set '32' or '64' as value for SET_ARCH"
294 echo "error: Please set '32' or '64' as value for SET_ARCH"
295 exit 1
295 exit 1
296 fi
296 fi
297 # Device specific configuration and U-Boot configuration
297 # Device specific configuration and U-Boot configuration
298 case "$RPI_MODEL" in
298 case "$RPI_MODEL" in
299 0)
299 0)
300 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
300 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
301 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
301 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
302 ;;
302 ;;
303 1)
303 1)
304 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
304 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
305 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
305 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
306 ;;
306 ;;
307 1P)
307 1P)
308 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
308 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
309 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
309 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
310 ;;
310 ;;
311 2)
311 2)
312 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
312 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
313 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
313 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
314 ;;
314 ;;
315 3)
315 3)
316 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
316 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
317 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
317 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
318 ;;
318 ;;
319 3P)
319 3P)
320 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
320 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
321 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
321 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
322 ;;
322 ;;
323 *)
323 *)
324 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
324 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
325 exit 1
325 exit 1
326 ;;
326 ;;
327 esac
327 esac
328
328
329 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
329 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
330 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
330 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
331 # Include bluetooth packages on supported boards
331 # Include bluetooth packages on supported boards
332 if [ "$ENABLE_BLUETOOTH" = true ] ; then
332 if [ "$ENABLE_BLUETOOTH" = true ] ; then
333 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
333 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
334 fi
334 fi
335 if [ "$ENABLE_WIRELESS" = true ] ; then
335 if [ "$ENABLE_WIRELESS" = true ] ; then
336 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
336 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
337 fi
337 fi
338 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
338 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
339 # Check if the internal wireless interface is not supported by the RPi model
339 # Check if the internal wireless interface is not supported by the RPi model
340 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
340 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
341 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
341 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
342 exit 1
342 exit 1
343 fi
343 fi
344 fi
344 fi
345
345
346 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
346 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
347 echo "error: You have to compile kernel sources, if you want to enable nexmon"
347 echo "error: You have to compile kernel sources, if you want to enable nexmon"
348 exit 1
348 exit 1
349 fi
349 fi
350
350
351 # Prepare date string for default image file name
351 # Prepare date string for default image file name
352 DATE="$(date +%Y-%m-%d)"
352 DATE="$(date +%Y-%m-%d)"
353 if [ -z "$KERNEL_BRANCH" ] ; then
353 if [ -z "$KERNEL_BRANCH" ] ; then
354 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
354 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
355 else
355 else
356 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
356 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
357 fi
357 fi
358
358
359 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
359 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
360 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
360 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
361 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
361 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
362 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
362 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
363 exit 1
363 exit 1
364 fi
364 fi
365 fi
365 fi
366
366
367 # Add cmake to compile videocore sources
367 # Add cmake to compile videocore sources
368 if [ "$ENABLE_VIDEOCORE" = true ] ; then
368 if [ "$ENABLE_VIDEOCORE" = true ] ; then
369 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
369 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
370 fi
370 fi
371
371
372 # Add deps for nexmon
372 # Add deps for nexmon
373 if [ "$ENABLE_NEXMON" = true ] ; then
373 if [ "$ENABLE_NEXMON" = true ] ; then
374 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
374 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
375 fi
375 fi
376
376
377 # Add libncurses5 to enable kernel menuconfig
377 # Add libncurses5 to enable kernel menuconfig
378 if [ "$KERNEL_MENUCONFIG" = true ] ; then
378 if [ "$KERNEL_MENUCONFIG" = true ] ; then
379 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
379 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
380 fi
380 fi
381
381
382 # Add ccache compiler cache for (faster) kernel cross (re)compilation
382 # Add ccache compiler cache for (faster) kernel cross (re)compilation
383 if [ "$KERNEL_CCACHE" = true ] ; then
383 if [ "$KERNEL_CCACHE" = true ] ; then
384 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
384 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
385 fi
385 fi
386
386
387 # Add cryptsetup package to enable filesystem encryption
387 # Add cryptsetup package to enable filesystem encryption
388 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
388 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
389 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
389 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
390 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
390 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
391
391
392 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
392 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
393 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
393 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
394 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
394 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
395 fi
395 fi
396
396
397 if [ -z "$CRYPTFS_PASSWORD" ] ; then
397 if [ -z "$CRYPTFS_PASSWORD" ] ; then
398 echo "error: no password defined (CRYPTFS_PASSWORD)!"
398 echo "error: no password defined (CRYPTFS_PASSWORD)!"
399 exit 1
399 exit 1
400 fi
400 fi
401 ENABLE_INITRAMFS=true
401 ENABLE_INITRAMFS=true
402 fi
402 fi
403
403
404 # Add initramfs generation tools
404 # Add initramfs generation tools
405 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
405 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
406 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
406 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
407 fi
407 fi
408
408
409 # Add device-tree-compiler required for building the U-Boot bootloader
409 # Add device-tree-compiler required for building the U-Boot bootloader
410 if [ "$ENABLE_UBOOT" = true ] ; then
410 if [ "$ENABLE_UBOOT" = true ] ; then
411 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
411 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
412 fi
412 fi
413
413
414 if [ "$ENABLE_USBBOOT" = true ] ; then
414 if [ "$ENABLE_USBBOOT" = true ] ; then
415 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
415 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
416 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
416 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
417 exit 1
417 exit 1
418 fi
418 fi
419 fi
419 fi
420
420
421 # Check if root SSH (v2) public key file exists
421 # Check if root SSH (v2) public key file exists
422 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
422 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
423 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
423 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
424 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
424 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
425 exit 1
425 exit 1
426 fi
426 fi
427 fi
427 fi
428
428
429 # Check if $USER_NAME SSH (v2) public key file exists
429 # Check if $USER_NAME SSH (v2) public key file exists
430 if [ -n "$SSH_USER_PUB_KEY" ] ; then
430 if [ -n "$SSH_USER_PUB_KEY" ] ; then
431 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
431 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
432 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
432 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
433 exit 1
433 exit 1
434 fi
434 fi
435 fi
435 fi
436
436
437 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
437 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
438 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
438 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
439 exit 1
439 exit 1
440 fi
440 fi
441
441
442 # Check if all required packages are installed on the build system
442 # Check if all required packages are installed on the build system
443 for package in $REQUIRED_PACKAGES ; do
443 for package in $REQUIRED_PACKAGES ; do
444 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
444 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
445 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
445 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
446 fi
446 fi
447 done
447 done
448
448
449 # If there are missing packages ask confirmation for install, or exit
449 # If there are missing packages ask confirmation for install, or exit
450 if [ -n "$MISSING_PACKAGES" ] ; then
450 if [ -n "$MISSING_PACKAGES" ] ; then
451 echo "the following packages needed by this script are not installed:"
451 echo "the following packages needed by this script are not installed:"
452 echo "$MISSING_PACKAGES"
452 echo "$MISSING_PACKAGES"
453
453
454 printf "\ndo you want to install the missing packages right now? [y/n] "
454 printf "\ndo you want to install the missing packages right now? [y/n] "
455 read -r confirm
455 read -r confirm
456 [ "$confirm" != "y" ] && exit 1
456 [ "$confirm" != "y" ] && exit 1
457
457
458 # Make sure all missing required packages are installed
458 # Make sure all missing required packages are installed
459 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
459 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
460 fi
460 fi
461
461
462 # Check if ./bootstrap.d directory exists
462 # Check if ./bootstrap.d directory exists
463 if [ ! -d "./bootstrap.d/" ] ; then
463 if [ ! -d "./bootstrap.d/" ] ; then
464 echo "error: './bootstrap.d' required directory not found!"
464 echo "error: './bootstrap.d' required directory not found!"
465 exit 1
465 exit 1
466 fi
466 fi
467
467
468 # Check if ./files directory exists
468 # Check if ./files directory exists
469 if [ ! -d "./files/" ] ; then
469 if [ ! -d "./files/" ] ; then
470 echo "error: './files' required directory not found!"
470 echo "error: './files' required directory not found!"
471 exit 1
471 exit 1
472 fi
472 fi
473
473
474 # Check if specified KERNELSRC_DIR directory exists
474 # Check if specified KERNELSRC_DIR directory exists
475 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
475 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
476 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
476 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
477 exit 1
477 exit 1
478 fi
478 fi
479
479
480 # Check if specified UBOOTSRC_DIR directory exists
480 # Check if specified UBOOTSRC_DIR directory exists
481 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
481 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
482 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
482 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
483 exit 1
483 exit 1
484 fi
484 fi
485
485
486 # Check if specified VIDEOCORESRC_DIR directory exists
486 # Check if specified VIDEOCORESRC_DIR directory exists
487 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
487 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
488 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
488 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
489 exit 1
489 exit 1
490 fi
490 fi
491
491
492 # Check if specified FBTURBOSRC_DIR directory exists
492 # Check if specified FBTURBOSRC_DIR directory exists
493 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
493 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
494 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
494 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
495 exit 1
495 exit 1
496 fi
496 fi
497
497
498 # Check if specified NEXMONSRC_DIR directory exists
498 # Check if specified NEXMONSRC_DIR directory exists
499 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
499 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
500 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
500 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
501 exit 1
501 exit 1
502 fi
502 fi
503
503
504 # Check if specified CHROOT_SCRIPTS directory exists
504 # Check if specified CHROOT_SCRIPTS directory exists
505 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
505 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
506 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
506 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
507 exit 1
507 exit 1
508 fi
508 fi
509
509
510 # Check if specified device mapping already exists (will be used by cryptsetup)
510 # Check if specified device mapping already exists (will be used by cryptsetup)
511 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
511 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
512 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
512 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
513 exit 1
513 exit 1
514 fi
514 fi
515
515
516 # Don't clobber an old build
516 # Don't clobber an old build
517 if [ -e "$BUILDDIR" ] ; then
517 if [ -e "$BUILDDIR" ] ; then
518 echo "error: directory ${BUILDDIR} already exists, not proceeding"
518 echo "error: directory ${BUILDDIR} already exists, not proceeding"
519 exit 1
519 exit 1
520 fi
520 fi
521
521
522 # Setup chroot directory
522 # Setup chroot directory
523 mkdir -p "${R}"
523 mkdir -p "${R}"
524
524
525 # Check if build directory has enough of free disk space >512MB
525 # Check if build directory has enough of free disk space >512MB
526 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
526 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
527 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
527 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
528 exit 1
528 exit 1
529 fi
529 fi
530
530
531 set -x
531 set -x
532
532
533 # Call "cleanup" function on various signals and errors
533 # Call "cleanup" function on various signals and errors
534 trap cleanup 0 1 2 3 6
534 trap cleanup 0 1 2 3 6
535
535
536 # Add required packages for the minbase installation
536 # Add required packages for the minbase installation
537 if [ "$ENABLE_MINBASE" = true ] ; then
537 if [ "$ENABLE_MINBASE" = true ] ; then
538 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
538 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
539 fi
539 fi
540
540
541 # Add parted package, required to get partprobe utility
541 # Add parted package, required to get partprobe utility
542 if [ "$EXPANDROOT" = true ] ; then
542 if [ "$EXPANDROOT" = true ] ; then
543 APT_INCLUDES="${APT_INCLUDES},parted"
543 APT_INCLUDES="${APT_INCLUDES},parted"
544 fi
544 fi
545
545
546 # Add dphys-swapfile package, required to enable swap
546 # Add dphys-swapfile package, required to enable swap
547 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
547 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
548 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
548 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
549 fi
549 fi
550
550
551 # Add dbus package, recommended if using systemd
551 # Add dbus package, recommended if using systemd
552 if [ "$ENABLE_DBUS" = true ] ; then
552 if [ "$ENABLE_DBUS" = true ] ; then
553 APT_INCLUDES="${APT_INCLUDES},dbus"
553 APT_INCLUDES="${APT_INCLUDES},dbus"
554 fi
554 fi
555
555
556 # Add iptables IPv4/IPv6 package
556 # Add iptables IPv4/IPv6 package
557 if [ "$ENABLE_IPTABLES" = true ] ; then
557 if [ "$ENABLE_IPTABLES" = true ] ; then
558 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
558 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
559 fi
559 fi
560 # Add apparmor for KERNEL_SECURITY
560 # Add apparmor for KERNEL_SECURITY
561 if [ "$KERNEL_SECURITY" = true ] ; then
561 if [ "$KERNEL_SECURITY" = true ] ; then
562 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
562 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
563 fi
563 fi
564
564
565 # Add openssh server package
565 # Add openssh server package
566 if [ "$ENABLE_SSHD" = true ] ; then
566 if [ "$ENABLE_SSHD" = true ] ; then
567 APT_INCLUDES="${APT_INCLUDES},openssh-server"
567 APT_INCLUDES="${APT_INCLUDES},openssh-server"
568 fi
568 fi
569
569
570 # Add alsa-utils package
570 # Add alsa-utils package
571 if [ "$ENABLE_SOUND" = true ] ; then
571 if [ "$ENABLE_SOUND" = true ] ; then
572 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
572 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
573 fi
573 fi
574
574
575 # Add rng-tools package
575 # Add rng-tools package
576 if [ "$ENABLE_HWRANDOM" = true ] ; then
576 if [ "$ENABLE_HWRANDOM" = true ] ; then
577 APT_INCLUDES="${APT_INCLUDES},rng-tools"
577 APT_INCLUDES="${APT_INCLUDES},rng-tools"
578 fi
578 fi
579
579
580 # Add fbturbo video driver
580 # Add fbturbo video driver
581 if [ "$ENABLE_FBTURBO" = true ] ; then
581 if [ "$ENABLE_FBTURBO" = true ] ; then
582 # Enable xorg package dependencies
582 # Enable xorg package dependencies
583 ENABLE_XORG=true
583 ENABLE_XORG=true
584 fi
584 fi
585
585
586 # Add user defined window manager package
586 # Add user defined window manager package
587 if [ -n "$ENABLE_WM" ] ; then
587 if [ -n "$ENABLE_WM" ] ; then
588 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
588 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
589
589
590 # Enable xorg package dependencies
590 # Enable xorg package dependencies
591 ENABLE_XORG=true
591 ENABLE_XORG=true
592 fi
592 fi
593
593
594 # Add xorg package
594 # Add xorg package
595 if [ "$ENABLE_XORG" = true ] ; then
595 if [ "$ENABLE_XORG" = true ] ; then
596 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
596 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
597 fi
597 fi
598
598
599 # Replace selected packages with smaller clones
599 # Replace selected packages with smaller clones
600 if [ "$ENABLE_REDUCE" = true ] ; then
600 if [ "$ENABLE_REDUCE" = true ] ; then
601 # Add levee package instead of vim-tiny
601 # Add levee package instead of vim-tiny
602 if [ "$REDUCE_VIM" = true ] ; then
602 if [ "$REDUCE_VIM" = true ] ; then
603 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
603 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
604 fi
604 fi
605
605
606 # Add dropbear package instead of openssh-server
606 # Add dropbear package instead of openssh-server
607 if [ "$REDUCE_SSHD" = true ] ; then
607 if [ "$REDUCE_SSHD" = true ] ; then
608 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
608 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
609 fi
609 fi
610 fi
610 fi
611
611
612 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
612 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
613 if [ "$ENABLE_SYSVINIT" = false ] ; then
613 if [ "$ENABLE_SYSVINIT" = false ] ; then
614 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
614 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
615 fi
615 fi
616
616
617 # Configure kernel sources if no KERNELSRC_DIR
617 # Configure kernel sources if no KERNELSRC_DIR
618 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
618 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
619 KERNELSRC_CONFIG=true
619 KERNELSRC_CONFIG=true
620 fi
620 fi
621
621
622 # Configure reduced kernel
622 # Configure reduced kernel
623 if [ "$KERNEL_REDUCE" = true ] ; then
623 if [ "$KERNEL_REDUCE" = true ] ; then
624 KERNELSRC_CONFIG=false
624 KERNELSRC_CONFIG=false
625 fi
625 fi
626
626
627 # Configure qemu compatible kernel
627 # Configure qemu compatible kernel
628 if [ "$ENABLE_QEMU" = true ] ; then
628 if [ "$ENABLE_QEMU" = true ] ; then
629 DTB_FILE=vexpress-v2p-ca15_a7.dtb
629 DTB_FILE=vexpress-v2p-ca15_a7.dtb
630 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
630 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
631 KERNEL_DEFCONFIG="vexpress_defconfig"
631 KERNEL_DEFCONFIG="vexpress_defconfig"
632 if [ "$KERNEL_MENUCONFIG" = false ] ; then
632 if [ "$KERNEL_MENUCONFIG" = false ] ; then
633 KERNEL_OLDDEFCONFIG=true
633 KERNEL_OLDDEFCONFIG=true
634 fi
634 fi
635 fi
635 fi
636
636
637 # Execute bootstrap scripts
637 # Execute bootstrap scripts
638 for SCRIPT in bootstrap.d/*.sh; do
638 for SCRIPT in bootstrap.d/*.sh; do
639 head -n 3 "$SCRIPT"
639 head -n 3 "$SCRIPT"
640 . "$SCRIPT"
640 . "$SCRIPT"
641 done
641 done
642
642
643 ## Execute custom bootstrap scripts
643 ## Execute custom bootstrap scripts
644 if [ -d "custom.d" ] ; then
644 if [ -d "custom.d" ] ; then
645 for SCRIPT in custom.d/*.sh; do
645 for SCRIPT in custom.d/*.sh; do
646 . "$SCRIPT"
646 . "$SCRIPT"
647 done
647 done
648 fi
648 fi
649
649
650 # Execute custom scripts inside the chroot
650 # Execute custom scripts inside the chroot
651 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
651 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
652 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
652 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
653 chroot_exec /bin/bash -x <<'EOF'
653 chroot_exec /bin/bash -x <<'EOF'
654 for SCRIPT in /chroot_scripts/* ; do
654 for SCRIPT in /chroot_scripts/* ; do
655 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
655 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
656 $SCRIPT
656 $SCRIPT
657 fi
657 fi
658 done
658 done
659 EOF
659 EOF
660 rm -rf "${R}/chroot_scripts"
660 rm -rf "${R}/chroot_scripts"
661 fi
661 fi
662
662
663 # Remove c/c++ build environment from the chroot
663 # Remove c/c++ build environment from the chroot
664 chroot_remove_cc
664 chroot_remove_cc
665
665
666 # Generate required machine-id
666 # Generate required machine-id
667 MACHINE_ID=$(dbus-uuidgen)
667 MACHINE_ID=$(dbus-uuidgen)
668 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
668 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
669 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
669 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
670
670
671 # APT Cleanup
671 # APT Cleanup
672 chroot_exec apt-get -y clean
672 chroot_exec apt-get -y clean
673 chroot_exec apt-get -y autoclean
673 chroot_exec apt-get -y autoclean
674 chroot_exec apt-get -y autoremove
674 chroot_exec apt-get -y autoremove
675
675
676 # Unmount mounted filesystems
676 # Unmount mounted filesystems
677 umount -l "${R}/proc"
677 umount -l "${R}/proc"
678 umount -l "${R}/sys"
678 umount -l "${R}/sys"
679
679
680 # Clean up directories
680 # Clean up directories
681 rm -rf "${R}/run/*"
681 rm -rf "${R}/run/*"
682 rm -rf "${R}/tmp/*"
682 rm -rf "${R}/tmp/*"
683
683
684 # Clean up APT proxy settings
684 # Clean up APT proxy settings
685 if [ "$KEEP_APT_PROXY" = false ] ; then
685 if [ "$KEEP_APT_PROXY" = false ] ; then
686 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
686 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
687 fi
687 fi
688
688
689 # Clean up files
689 # Clean up files
690 rm -f "${ETC_DIR}/ssh/ssh_host_*"
690 rm -f "${ETC_DIR}/ssh/ssh_host_*"
691 rm -f "${ETC_DIR}/dropbear/dropbear_*"
691 rm -f "${ETC_DIR}/dropbear/dropbear_*"
692 rm -f "${ETC_DIR}/apt/sources.list.save"
692 rm -f "${ETC_DIR}/apt/sources.list.save"
693 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
693 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
694 rm -f "${ETC_DIR}/*-"
694 rm -f "${ETC_DIR}/*-"
695 rm -f "${ETC_DIR}/resolv.conf"
695 rm -f "${ETC_DIR}/resolv.conf"
696 rm -f "${R}/root/.bash_history"
696 rm -f "${R}/root/.bash_history"
697 rm -f "${R}/var/lib/urandom/random-seed"
697 rm -f "${R}/var/lib/urandom/random-seed"
698 rm -f "${R}/initrd.img"
698 rm -f "${R}/initrd.img"
699 rm -f "${R}/vmlinuz"
699 rm -f "${R}/vmlinuz"
700 rm -f "${R}${QEMU_BINARY}"
700 rm -f "${R}${QEMU_BINARY}"
701
701
702 if [ "$ENABLE_QEMU" = true ] ; then
702 if [ "$ENABLE_QEMU" = true ] ; then
703 # Setup QEMU directory
703 # Setup QEMU directory
704 mkdir "${BASEDIR}/qemu"
704 mkdir "${BASEDIR}/qemu"
705
705
706 # Copy kernel image to QEMU directory
706 # Copy kernel image to QEMU directory
707 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
707 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
708
708
709 # Copy kernel config to QEMU directory
709 # Copy kernel config to QEMU directory
710 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
710 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
711
711
712 # Copy kernel dtbs to QEMU directory
712 # Copy kernel dtbs to QEMU directory
713 for dtb in "${BOOT_DIR}/"*.dtb ; do
713 for dtb in "${BOOT_DIR}/"*.dtb ; do
714 if [ -f "${dtb}" ] ; then
714 if [ -f "${dtb}" ] ; then
715 install_readonly "${dtb}" "${BASEDIR}/qemu/"
715 install_readonly "${dtb}" "${BASEDIR}/qemu/"
716 fi
716 fi
717 done
717 done
718
718
719 # Copy kernel overlays to QEMU directory
719 # Copy kernel overlays to QEMU directory
720 if [ -d "${BOOT_DIR}/overlays" ] ; then
720 if [ -d "${BOOT_DIR}/overlays" ] ; then
721 # Setup overlays dtbs directory
721 # Setup overlays dtbs directory
722 mkdir "${BASEDIR}/qemu/overlays"
722 mkdir "${BASEDIR}/qemu/overlays"
723
723
724 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
724 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
725 if [ -f "${dtb}" ] ; then
725 if [ -f "${dtb}" ] ; then
726 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
726 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
727 fi
727 fi
728 done
728 done
729 fi
729 fi
730
730
731 # Copy u-boot files to QEMU directory
731 # Copy u-boot files to QEMU directory
732 if [ "$ENABLE_UBOOT" = true ] ; then
732 if [ "$ENABLE_UBOOT" = true ] ; then
733 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
733 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
734 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
734 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
735 fi
735 fi
736 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
736 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
737 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
737 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
738 fi
738 fi
739 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
739 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
740 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
740 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
741 fi
741 fi
742 fi
742 fi
743
743
744 # Copy initramfs to QEMU directory
744 # Copy initramfs to QEMU directory
745 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
745 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
746 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
746 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
747 fi
747 fi
748 fi
748 fi
749
749
750 # Calculate size of the chroot directory in KB
750 # Calculate size of the chroot directory in KB
751 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
751 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
752
752
753 # Calculate the amount of needed 512 Byte sectors
753 # Calculate the amount of needed 512 Byte sectors
754 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
754 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
755 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
755 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
756 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
756 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
757
757
758 # The root partition is EXT4
758 # The root partition is EXT4
759 # This means more space than the actual used space of the chroot is used.
759 # This means more space than the actual used space of the chroot is used.
760 # As overhead for journaling and reserved blocks 35% are added.
760 # As overhead for journaling and reserved blocks 35% are added.
761 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
761 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
762
762
763 # Calculate required image size in 512 Byte sectors
763 # Calculate required image size in 512 Byte sectors
764 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
764 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
765
765
766 # Prepare image file
766 # Prepare image file
767 if [ "$ENABLE_SPLITFS" = true ] ; then
767 if [ "$ENABLE_SPLITFS" = true ] ; then
768 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
768 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
769 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
769 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
770 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
770 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
771 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
771 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
772
772
773 # Write firmware/boot partition tables
773 # Write firmware/boot partition tables
774 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
774 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
775 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
775 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
776 EOM
776 EOM
777
777
778 # Write root partition table
778 # Write root partition table
779 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
779 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
780 ${TABLE_SECTORS},${ROOT_SECTORS},83
780 ${TABLE_SECTORS},${ROOT_SECTORS},83
781 EOM
781 EOM
782
782
783 # Setup temporary loop devices
783 # Setup temporary loop devices
784 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
784 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
785 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
785 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
786 else # ENABLE_SPLITFS=false
786 else # ENABLE_SPLITFS=false
787 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
787 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
788 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
788 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
789
789
790 # Write partition table
790 # Write partition table
791 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
791 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
792 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
792 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
793 ${ROOT_OFFSET},${ROOT_SECTORS},83
793 ${ROOT_OFFSET},${ROOT_SECTORS},83
794 EOM
794 EOM
795
795
796 # Setup temporary loop devices
796 # Setup temporary loop devices
797 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
797 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
798 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
798 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
799 fi
799 fi
800
800
801 if [ "$ENABLE_CRYPTFS" = true ] ; then
801 if [ "$ENABLE_CRYPTFS" = true ] ; then
802 # Create dummy ext4 fs
802 # Create dummy ext4 fs
803 mkfs.ext4 "$ROOT_LOOP"
803 mkfs.ext4 "$ROOT_LOOP"
804
804
805 # Setup password keyfile
805 # Setup password keyfile
806 touch .password
806 touch .password
807 chmod 600 .password
807 chmod 600 .password
808 echo -n ${CRYPTFS_PASSWORD} > .password
808 echo -n ${CRYPTFS_PASSWORD} > .password
809
809
810 # Initialize encrypted partition
810 # Initialize encrypted partition
811 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
811 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
812
812
813 # Open encrypted partition and setup mapping
813 # Open encrypted partition and setup mapping
814 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
814 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
815
815
816 # Secure delete password keyfile
816 # Secure delete password keyfile
817 shred -zu .password
817 shred -zu .password
818
818
819 # Update temporary loop device
819 # Update temporary loop device
820 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
820 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
821
821
822 # Wipe encrypted partition (encryption cipher is used for randomness)
822 # Wipe encrypted partition (encryption cipher is used for randomness)
823 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
823 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
824 fi
824 fi
825
825
826 # Build filesystems
826 # Build filesystems
827 mkfs.vfat "$FRMW_LOOP"
827 mkfs.vfat "$FRMW_LOOP"
828 mkfs.ext4 "$ROOT_LOOP"
828 mkfs.ext4 "$ROOT_LOOP"
829
829
830 # Mount the temporary loop devices
830 # Mount the temporary loop devices
831 mkdir -p "$BUILDDIR/mount"
831 mkdir -p "$BUILDDIR/mount"
832 mount "$ROOT_LOOP" "$BUILDDIR/mount"
832 mount "$ROOT_LOOP" "$BUILDDIR/mount"
833
833
834 mkdir -p "$BUILDDIR/mount/boot/firmware"
834 mkdir -p "$BUILDDIR/mount/boot/firmware"
835 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
835 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
836
836
837 # Copy all files from the chroot to the loop device mount point directory
837 # Copy all files from the chroot to the loop device mount point directory
838 rsync -a "${R}/" "$BUILDDIR/mount/"
838 rsync -a "${R}/" "$BUILDDIR/mount/"
839
839
840 # Unmount all temporary loop devices and mount points
840 # Unmount all temporary loop devices and mount points
841 cleanup
841 cleanup
842
842
843 # Create block map file(s) of image(s)
843 # Create block map file(s) of image(s)
844 if [ "$ENABLE_SPLITFS" = true ] ; then
844 if [ "$ENABLE_SPLITFS" = true ] ; then
845 # Create block map files for "bmaptool"
845 # Create block map files for "bmaptool"
846 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
846 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
847 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
847 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
848
848
849 # Image was successfully created
849 # Image was successfully created
850 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
850 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
851 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
851 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
852 else
852 else
853 # Create block map file for "bmaptool"
853 # Create block map file for "bmaptool"
854 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
854 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
855
855
856 # Image was successfully created
856 # Image was successfully created
857 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
857 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
858
858
859 # Create qemu qcow2 image
859 # Create qemu qcow2 image
860 if [ "$ENABLE_QEMU" = true ] ; then
860 if [ "$ENABLE_QEMU" = true ] ; then
861 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
861 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
862 QEMU_SIZE=16G
862 QEMU_SIZE=16G
863
863
864 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
864 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
865 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
865 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
866
866
867 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
867 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
868 fi
868 fi
869 fi
869 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant